<?php

// +---------------------------------------------------------------------------+
// | Daily Quote Plugin v1.0.5 for Geeklog - The Ultimate Weblog                 |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Retrieve access settings
$query = DB_query("SELECT anonview FROM {$DQ_TABLES['dailyquote_settings']}");
list($anonview) = DB_fetchArray($query);
// Check user has rights to access this page
if (($anonview == '0') && ($_USER['uid'] < 2)) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the dailyquote page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_DQ00['access_denied']);
    $display .= $LANG_DQ00['access_denied_msg1'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

//displays the google-like page nav
function display_pagenav($sort, $asc, $page)
{
    global $_TABLES, $_CONF, $DQ_TABLES, $LANG_DQ;

    //print page nav here
    $query1 = DB_query ("SELECT COUNT(*) AS numquotes FROM {$DQ_TABLES['dailyquote_quotes']} WHERE Status='1'");
    list($numquotes) = DB_fetchArray($query1);
    $query2 = DB_query("SELECT indexdisplim AS displim FROM {$DQ_TABLES['dailyquote_settings']}");
    list( $displim) = DB_fetchArray($query2);
    if ($numquotes > $displim) {
        $T = new Template($_CONF['path'] . 'plugins/dailyquote/templates');
        $T->set_file('page', 'pagenav.thtml');
        $prevpage = $page - 1;
        $nextpage = $page + 1;
        $pagestart = ($page - 1) * 25;
        if ((isset($sort)) && (isset($asc))){
            $sortvar = "sort=".$sort."&amp;asc=".$asc;
        }
        elseif (isset($sort)){
            $sortvar = "sort=".$sort;
        }
        elseif (isset($asc)){
            $ascvar = "asc".$asc;
        }
        $baseurl = $_CONF['site_url'] . '/dailyquote/index.php?' . $sortvar . $ascvar;
        $numpages = ceil ($numquotes / $displim);
        $T->set_var ('google_paging',
                COM_printPageNavigation ($baseurl, $page, $numpages));
        $T->parse('output','page');
        $retval .= $T->finish($T->get_var('output'));
    }
    return $retval;
}

//displays the quotes listing
function display_quote($sort, $asc, $page){
    global $_TABLES, $_CONF, $DQ_TABLES, $LANG_DQ;

    if ((isset ($sort)) && ($sort == '3')){//this sort option to be removed ... category index page is sufficient
        $catcol = ", Name";
        $cattab = ", {$DQ_TABLES['dailyquote_cat']} c";
        $catwh = " AND c.ID=l.CID";
    }

    $sql = "SELECT DISTINCT q.ID, Quotes, Quoted, Title, Source, Sourcedate, Date, q.UID";
    if ((isset ($sort)) && ($sort == '3')){
        $sql .= $catcol;
    }
    $sql .= " FROM {$DQ_TABLES['dailyquote_quotes']} q, {$DQ_TABLES['dailyquote_lookup']} l";
    if ((isset ($sort)) && ($sort == '3')){
        $sql .= $cattab;
    }
    $sql .= " WHERE q.Status='1'";
    if ((isset ($sort)) && ($sort == '3')){
        $sql .= $catwh;
    }
    $sql .= " AND l.Status='1' AND l.QID=q.ID";
    if ((isset ($sort)) && ($sort != '6')){
        if($sort == '1'){//sort by quote
            $sorted = "Quotes";
        }
        elseif($sort == '2'){//sort by quoted
            $sorted = "Quoted";
        }
        //sort by category -- returns all quotes per category
        // so if a quote belongs to multiple categories it will display under each of those cats.
        elseif($sort == '3'){ 
            $sorted = "Name";
        }
        elseif($sort == '4'){//sort by contributor
            $sorted = "UID";
        }
        elseif($sort == '5'){//sort by date
            $sorted = "Date";
        }
        $sql .= " ORDER BY $sorted";
    }
    else $sql .= " ORDER BY Date";
    if (isset($asc)){
        if ($asc == 1){
            $asced = "ASC";        
        }
        elseif ($asc == 2){
            $asced = "DESC";
        }
        $sql .= " $asced";
    }
    else $sql .= " DESC";

    // Retrieve results per page setting
    $query = DB_query("SELECT indexdisplim AS displim FROM {$DQ_TABLES['dailyquote_settings']}");
    list( $displim) = DB_fetchArray($query);
    $limit = ($displim * $page) - $displim;
    $sql .= " LIMIT $limit, $displim";

    $result = DB_query($sql);
    if (!$result){
        $retval = $LANG_DQ['disperror'];
        COM_errorLog("An error occured while retrieving list of quotes",1);
    }

    //display quotes if any to display
    else {
        $T = new Template($_CONF['path'] . 'plugins/dailyquote/templates');
        $T->set_file('page', 'dispquotesheader.thtml');
        $T->parse('output','page');
        $retval .= $T->finish($T->get_var('output'));
        $numrows = DB_numRows($result);
        if ($numrows>0){
            $retval .= display_pagenav($sort, $asc, $page);
            while ($row = DB_fetchArray($result)){
                $T = new Template($_CONF['path'] . 'plugins/dailyquote/templates');
                $T->set_file('page', 'singlequote.thtml');
                if (!empty($row['Title'])){
                    $title = '<p style="text-align: left; font-weight: bold; text-decoration: underline;">';
                    $title .= $row['Title'];
                    $title .= '</p>';
                    $T->set_var('title', $title);
                }
                $T->set_var('quote', $row['Quotes']);
                $quoted = ggllink($row['Quoted']);
                $T->set_var('quoted', $quoted);
                if (!empty($row['Source'])){
                    $T->set_var('source', '&nbsp;--&nbsp;' . $row['Source']);
                }
                if (!empty($row['Sourcedate'])){
                    $T->set_var('sourcedate', '&nbsp;&nbsp;(' . $row['Sourcedate'] . ')');
                }
                $T->set_var('subm_by', $LANG_DQ['subm_by']);
                $contr = DB_query("SELECT UID, username FROM {$_TABLES['users']} WHERE uid={$row['UID']}");
                list($uid,$username) = DB_fetchArray($contr);
                $username = prflink($uid,$username);
                $T->set_var('contr', $username);
                $T->set_var('datecontr', $row['Date']);
                $cat = DB_query("SELECT c.ID, c.Name FROM {$DQ_TABLES['dailyquote_cat']} c, {$DQ_TABLES['dailyquote_lookup']} l WHERE {$row['ID']}=l.QID AND c.ID=l.CID AND l.Status='1'");
                $i = 0;
                $catlist = "";
                while ($catrow = DB_fetchArray($cat)){
                    if ($i > 0){
                        $catlist .= ", ";
                    }
                    $catlink = catlink($catrow['ID'],$catrow['Name']);
                    $catlist = $catlist . $catlink;
                    $i++;
                }
                $T->set_var('cat', $LANG_DQ['cat']);
                $T->set_var('dispcat', $catlist);
                if(SEC_hasRights('dailyquote.edit')){
                    $editlink = '<a href="' . $_CONF['site_url'] . '/dailyquote/manage.php?qid=';
                    $editlink .= $row['ID'] . '">';
                    $editlink .= '<img src="' . $_CONF['site_url'] . '/dailyquote/images/edit.gif' . '" alt="';
                    $editlink .= $LANG_DQ['editlink'];
                    $editlink .= '" border="0" />';
                    $editlink .= '</a>';
                    $T->set_var('editlink', $editlink);
                }
                $T->parse('output','page');
                $retval .= $T->finish($T->get_var('output'));
            }
            $retval .= display_pagenav($sort, $asc, $page);
        }
        else $retval .= "<p align=\"center\">".$LANG_DQ['StatsMsg2']."</p>";
            $T = new Template($_CONF['path'] . 'plugins/dailyquote/templates');
            $T->set_file('page', 'dispquotesfooter.thtml');
            $T->parse('output','page');
            $retval .= $T->finish($T->get_var('output'));
    }
    return $retval;
}

/* 
* Main Function
*/

if(eregi('1.3.1',VERSION)){
    $dqblockmenu = array(dqmenu);
    $display = COM_siteHeader($dqblockmenu);
} else {
    $display = COM_siteHeader();
}
$display .= COM_startBlock($LANG_DQ['indextitle']);
$T = new Template($_CONF['path'] . 'plugins/dailyquote/templates');
$T->set_file('page', 'dqheader.thtml');
$T->set_var('header', $LANG_DQ00['plugin']);
$T->set_var('site_url', $_CONF['site_url']);
$T->set_var('plugin', 'dailyquote');

if (isset($_GET['msg'])){
    $msg = "msg" . $_GET['msg'];
    $T->set_var('msg', $LANG_DQ[$msg]);
}

$T->set_var('indextitle', $LANG_DQ['indextitle']);
$T->set_var('indexintro', $LANG_DQ['indexintro']);
$T->parse('output','page');
$display .= $T->finish($T->get_var('output'));

//display a row of pertinent links
if(!eregi('1.3.1',VERSION)){
    $display .= link_row();
}

$display .= random_quote();

if (isset($_GET['sort'])){
    $sort = $_GET['sort'];
}
if (isset($_GET['asc'])){
    $asc = $_GET['asc'];
}
if (empty($_GET['page'])) {
    $page = 1;
}

//display the sort by menu
$display .= sort_by_menu();

//display quote listing by date desc as default
$display .= display_quote($sort, $asc, $page);

$T = new Template($_CONF['path'] . 'plugins/dailyquote/templates');
$T->set_file('page', 'dqfooter.thtml');
$T->parse('output','page');
$display .= $T->finish($T->get_var('output'));
$display .= COM_endBlock();
$display .= COM_siteFooter();
echo $display;
?>