<?php

/**
* SQL Commands for the Daily Quote Plugin
* Last updated Nov 26/2004
* ajdeeley@summitpages.ca
**/

#
# Table structure for dailyquote quotation text - main table
#

$_SQL[] = "CREATE TABLE {$DQ_TABLES['dailyquote_quotes']} (
  ID INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  Quotes TEXT,
  Quoted TEXT,
  Title TEXT,
  Source TEXT,
  Sourcedate VARCHAR(16),
  Date DATE NOT NULL default 'CURDATE()',
  UID INT NOT NULL default '1',
  Status TINYINT(2) NOT NULL default '0',
  UNIQUE Quotes (Quotes(32))
) TYPE=MyISAM";

#
# Table structure for dailyquote categories
#

$_SQL[] = "CREATE TABLE {$DQ_TABLES['dailyquote_cat']} (
  ID INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  Name VARCHAR(64) NOT NULL default 'Miscellany',
  Status TINYINT(1) NOT NULL default '0',
  UNIQUE Name (Name(10))
) TYPE=MyISAM";

#
# Table structure for lookup table
#

$_SQL[] = "CREATE TABLE {$DQ_TABLES['dailyquote_lookup']} (
  QID MEDIUMINT UNSIGNED NOT NULL,
  CID MEDIUMINT UNSIGNED NOT NULL,
  UID MEDIUMINT UNSIGNED NOT NULL,
  Status TINYINT(1) NOT NULL default '0',
  PRIMARY KEY(QID,CID,UID)
) TYPE=MyISAM";

#
# Table structure for dailyquote prefs
#

$_SQL[] = "CREATE TABLE {$DQ_TABLES['dailyquote_settings']} (
  indexdisplim TINYINT(3) UNSIGNED NOT NULL default '10',
  searchdisplim TINYINT(3) UNSIGNED NOT NULL default '50',
  queue TINYINT(1) NOT NULL default '1',
  anonadd TINYINT(1) NOT NULL default '0',
  anonview TINYINT(1) NOT NULL default '1',
  loginadd TINYINT(1) NOT NULL default '1',
  loginaddcat TINYINT(1) NOT NULL default '1',
  loginbatch TINYINT(1) NOT NULL default '0',
  cntrblkenable TINYINT(1) NOT NULL default '0',
  cntrblkpos TINYINT(1) NOT NULL default '2',
  cntrblkhome TINYINT(1) NOT NULL default '1',
  blk1 TINYINT(1) NOT NULL default '0',
  blk2 TINYINT(1) NOT NULL default '0',
  blk3 TINYINT(1) NOT NULL default '0',
  blk4 TINYINT(1) NOT NULL default '1',
  blk5 TINYINT(1) NOT NULL default '0',
  blk6 TINYINT(1) NOT NULL default '0',
  blk7 TINYINT(1) NOT NULL default '0',
  blk8 TINYINT(1) NOT NULL default '0',
  blk9 TINYINT(1) NOT NULL default '1',
  blk10 TINYINT(1) NOT NULL default '0',
  blk11 TINYINT(1) NOT NULL default '1',
  blk12 TINYINT(1) NOT NULL default '0',
  blk13 TINYINT(1) NOT NULL default '0',
  blk14 TINYINT(1) NOT NULL default '0',
  gglink TINYINT(1) NOT NULL default '1',
  cacheupdate INT UNSIGNED,
  cacheperiod MEDIUMINT UNSIGNED NOT NULL default '0',
  cacheQID INT UNSIGNED,
  whatsnew TINYINT(1) NOT NULL default '0'
) TYPE=MyISAM";

?>